#ifndef GREATTYPES_H
#define GREATTYPES_H

#include <string>
#include <map>
#include <vector>
#include <set>

#include "UdmDom.h"
#include "UdmGme.h"
#include "UmlExt.h"
#include "GeneralBackend.h" 

typedef  GeneralBackend* GeneralBackendPtr;

typedef Udm::Object Object;

class Match
{
public:
	std::map<GR::ObjectWrapper, Object> grObj2BoundObj;
	std::map<string, Object> boundObjMap;  
	
	std::set< pair<unsigned long, Object> > boundObject;

	//Different Object in different data network may have the same unique id
	std::set<GR::ObjectLink> boundGRLink;
};

typedef std::map<GR::ObjectWrapper, Udm::Object> PassAlongPacket;
typedef std::list<PassAlongPacket> PassAlongPackets;
typedef std::set<GR::PassAlong> PassAlongSet;
typedef std::vector<Match> MatchVector;
typedef  Udm::DataNetwork* UdmDataNetworkPtr;


#endif //GREATTYPES_H