#ifndef GeneralBackend_H
#define GeneralBackend_H

#include "UmlExt.h"
#include "UdmDom.h"
#include "UdmGme.h"
#include "GR.h"
#include <map>

class GeneralBackend
{
	typedef Udm::Object Object;
public:	
	GeneralBackend(map<string, Uml::Diagram *> umlDiagrams) : umlDiagramMap(umlDiagrams) {};
	GeneralBackend(map<string, Uml::Diagram *> umlDiagrams, map<string, Object> globalObjs) 
		: umlDiagramMap(umlDiagrams), globalObjectMap(globalObjs) {};

	bool GetUmlClass(const GR::ObjectWrapper& grObj, Uml::Class& clsFound);
	bool GetUmlClass(const string& metaName, const string& clsName, Uml::Class& clsFound);

	bool GetObject(const GR::ObjectWrapper& grObj, Object& object);
	bool GetGlobalObject(const string& goname, Object& object);
//	bool GetRootObject(const string& fileId,Object& object);

	Object CreateUdmObject(GR::ObjectWrapper &parentCO, GR::ObjectWrapper &childCO, const Udm::Object::CompositionInfo &compInfo);
	void DeleteUdmObject(Object& object);
	void DeleteUdmObject(const GR::ObjectWrapper& grObj);

	void CreateUdmAssociation(const GR::ObjectLink& clink);
	void DeleteUdmAssociation(const GR::ObjectLink& clink);
	void GetAdjacentObjects(const GR::ObjectLink& link, Object& object, bool isSrc, set<Object>& adjObjs);

protected:
//	map<string, Udm::DataNetwork *> backendMap; 
	map<string, Uml::Diagram *> umlDiagramMap;
	map<string, Object> globalObjectMap;
	map<int, set<int> > deletedObjectMap;
	void AddDeleteObject(Object& object);
};
#endif //GeneralBackend_H

