#ifndef GRCGENOPS_H
#define GRCGENOPS_H

#include <map>
#include <list>
#include <string>
#include "GR.h"

//
typedef std::map< std::string, std::list< std::string> > CmpFuncSpecTypes_t;

// generates <filenamebase>_genops.cpp, <filenamebase>_genops.h,
extern void generateSpecCompareFunctions( const CmpFuncSpecTypes_t& cmpFuncSpecTypes, const std::string& filenamebase);
extern void createIncludeMetaFiles( const std::string& fnbase, const std::list< std::string>& metanames);

//
class GRCCmpFuncCollector : public GR::Visitor {
public:
	virtual void Visit_RootFolder(const GR::RootFolder&);
	const CmpFuncSpecTypes_t& specTypes() { return _specTypes;}

protected:
	virtual void Visit_RewritingRule(const GR::RewritingRule&);

private:
	CmpFuncSpecTypes_t _specTypes;
};
#endif //GRCGENOPS_H
