#ifndef GRCLOADER_H
#define GRCLOADER_H

#include <string>
#include <map>
#include <windows.h>	// for HINSTANCE
#include "Uml.h"
#include "GRCExport.h"

///////////////////////////////////////////////////////////////////////////////
typedef std::map<std::string, Uml::Diagram>  StrUmlDiagramMap_t;

///////////////////////////////////////////////////////////////////////////////
class GRCC_DLL GRCLoader {
public:
	GRCLoader( const std::string& dllFullName, const StrUmlDiagramMap_t& metas)
		: _dllFullName( dllFullName), _metas( metas), _hDLL( 0)
	{}
	HINSTANCE loadDll();
	void closeDll();

private:
	std::string _dllFullName;
	StrUmlDiagramMap_t _metas;
	HINSTANCE _hDLL;
};

#endif // GRCLOADER_H
