#ifndef GRCFORCG_H
#define GRCFORCG_H

#include "GRCC.h"

struct GRCC_DLL CCodeGenforCGConfig : public CCodeGenConfig
{
	CCodeGenforCGConfig( const CCodeGenConfig& cfg) : CCodeGenConfig( cfg)
	{}
	// if set to true, domain-specific UDM API & AM, guard code 
	// static link libs are linked against the CG generated files
	bool _useLib;
	// filename base for CG
	std::string _genFileName;
};

class GRCC_DLL GRCforCG {
public:
	GRCforCG( const CCodeGenforCGConfig& ccfg);
	// generates mpc file, which can be used to build the CG generated files.
	// returns with mpc filename
	std::string generateMpc();
	// generates VS project file, returns with the name of the generated file.
	std::string generateVisualStudioProject();
	// generates transformation executable file, returns with the name of the generated file.
	std::string generateExe();

private:
	CCodeGenforCGConfig _ccfg;
};


#endif //GRCFORCG_H