#ifndef CINT_CODE_GATHERER_H
#define CINT_CODE_GATHERER_H

#include <iostream>
#include <iomanip>
#include <fstream>

#include "GR.h"

#include "ICINTCodeGatherer.h"
#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

using namespace GR;

typedef std::vector<std::string> StrVec;

class CINTCodeGatherer : public   Visitor,
                         public  ICINTCodeGatherer
{
public:
	
  virtual ~CINTCodeGatherer();

private:
	string filename;
	ofstream cppfile,deffile,headerfile;
	vector<string> path;
  HINSTANCE m_hDLL;

  UserCodeGenConfig m_cfg;

  std::string m_dllFullName;

protected:
//   void split(const std::string& str,
//                    StrVec& strVec,
//               const std::string& delim = " ");

  void generateMetaMakeInclude();
  void generateMainMakeInclude(const std::string& tmpDir,
                                               const std::string& metaBaseName);
  void createBlockEnd(bool);
public:

  void generateDll(const UserCodeGenConfig& cfg); 
  HINSTANCE  loadDll();
  void closeDll();

public:
	virtual void Visit_RootFolder(const RootFolder&);
	string GetDllName() { return filename + ".dll"; }

protected:
	virtual void Visit_RewritingRule(const RewritingRule&);
	bool MakeGuardFunction(const RewritingRule& rule);
	bool MakeAttributeMappingFunction(const RewritingRule& rule);
	void CreateSignature(const RewritingRule& rule, char *sigvar, char *ret, bool onlyBoundObjects);
};

#endif // CINT_CODE_GATHERER_H
