#ifndef I_CINT_CODE_GATHERER_H
#define I_CINT_CODE_GATHERER_H

#include "../Engine/GReATTypes.h"

typedef std::map<std::string, Uml::Diagram>  StrUmlDiagramMap;
typedef std::vector<std::string> StrVec;
struct UserCodeGenConfig
{
  //full path
  std::string m_depFileName;
  //GRT
  UdmDataNetworkPtr m_transf;
  //full path
  std::string m_udmDirName;
  
  //all the names of meta used in GRT
  StrUmlDiagramMap m_metas;

  //user code
  StrVec m_incFiles;
  StrVec m_libFiles;
  StrVec m_incDirs;
  StrVec m_libDirs;

  //debug or release
  bool m_debug; // true means debug libraries
};
//==============================
class ICINTCodeGatherer
{
public:
  virtual ~ICINTCodeGatherer() {}
  virtual void generateDll(const UserCodeGenConfig& cfg) = 0;
  virtual HINSTANCE  loadDll() = 0;
  virtual void closeDll() = 0;
  
};

#endif // I_CINT_CODE_GATHERER_H