/* NAME:	Logging (Dummy)
 * AUTHOR:	Attila Vizhanyo - viza@isis-server.isis.vanderbilt.edu
 *
 * Logging functions. (Dummy, should be more sophisticated for dumping.)
 */
#ifndef __LOGGING_H
#define __LOGGING_H

#ifdef _MSC_VER
#pragma warning (disable : 4786)
#pragma warning (disable : 4503) 
#endif

#include <string>

#define INVALID	( std::string("Invalid"))
#define BLOCK ( std::string("Block"))
#define FORBLOCK ( std::string("ForBlock"))
#define REFERENCE ( std::string("Reference"))
#define TEST ( std::string("Test"))
#define FORTEST ( std::string("ForTest"))
#define RULE ( std::string("Rule"))
#define CASE ( std::string("Case"))

// Warning and Error counters.
extern int g_cntWrn;
extern int g_cntErr;

// Creates 'TranslatorLog.txt' under 'logFilePath'.
extern void createLogFile( const std::string& logFilePath);
// Close log file
extern void closeLogFile();
// Prints 'logMsg' to cout and log file.
extern void printLogMsg( const std::string& logMsg);
// Prints WARNING+'wrnMsg' to cout and log file, and increment warning counter.
extern void printWarning( const std::string& wrnMsg);
// Prints ERROR+'errMsg' to cout and log file, and increment error counter.
extern void printError( const std::string& errMsg);
// Used for logging rules. 
// 'name' is name of the rule.
// 'type' is ususally one of rule type string macros, see above.
// 'depth' is used for tabulation representing rule hierarchies.
extern void logRule( const std::string& type, const std::string& name, int depth);

#endif //__LOGGING_H
