#if !defined(GRDebugGRDI_ERROR_h)
#define GRDebugGRDI_ERROR_h

#include <string>

namespace GRDI
{
///
///    Errors


typedef int GRDIError;


/// @subsection UniversalErrors Universal Errors
/// Universal errors. These errors may be returned by any GRDI function.
//@{
/// no error
#define GRDI_ERROR_NONE                 ((GRDIError)0)

/// internal error 
#define GRDI_ERROR_INTERNAL             ((GRDIError)11)
//@}

#define GRDI_ERROR_INVALID_CONTEXT		((GRDIError)20)

/// There are no context on the call stack. 
#define GRDI_ERROR_NO_MORE_CONTEXTES		((GRDIError)21)


///Invalid function. 
#define GRDI_ERROR_INVALID_FUNCTION   ((GRDIError)30)

///Invalid location. 
#define GRDI_ERROR_INVALID_LOCATION     ((GRDIError)31)

/// The designated location already has a breakpoint. 
#define GRDI_ERROR_DUPLICATE            ((GRDIError)32)

///There's no breakpoint at the designated location. 
#define GRDI_ERROR_NOT_FOUND            ((GRDIError)33)

 ///Invalid variable. 
#define   GRDI_ERROR_INVALID_VARIABLE      ((GRDIError)34) 


///Thread already suspended. 
#define   GRDI_ERROR_ALREADY_SUSPENDED       ((GRDIError)35) 

///Thread was not suspended. 
#define   GRDI_ERROR_NOT_SUSPENDED           ((GRDIError)36) 


class GRDException : public std::exception
{
protected:

  std::string m_descr;
public:
  GRDException (const std::string& d) throw() : m_descr(d) { }
	GRDException (const char *d) throw() : m_descr(d) { }
	virtual const char *what() const throw() { return m_descr.c_str(); }
};


};

#endif //GRDebugGRDI_ERROR_h