#if !defined(AFX_SOURCETXTVIEW_H__4340A825_DC98_4FD1_9711_23ED9BBD6E37__INCLUDED_)
#define AFX_SOURCETXTVIEW_H__4340A825_DC98_4FD1_9711_23ED9BBD6E37__INCLUDED_

// SourceTxtView view
#include <string>
#include "../GRDebugInterface/GRDebugTypes.h"
#include "../GRDebugger/IGRDebuggerView.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SourceTxtView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
typedef std::map<GRDI::LocationID, HTREEITEM> LocIDItemMap;

typedef std::map<HTREEITEM, GRDI::LocationID> ItemLocIDMap;
typedef std::map<HTREEITEM, GRDI::VariableValueMap> ItemVarMap;
typedef std::set<HTREEITEM> ItemSet;
typedef std::map<int, GRDI::IVariablePtr> IntIVariablePtrMap;



class SourceTxtView : public CTreeView

{
public:
  typedef enum{CALL = 1, BOUNDARY = 2, REFERENCE = 4, BREAKPOINT = 8, CURRENT = 16} SrcItemType;
protected:
	SourceTxtView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(SourceTxtView)
  CImageList*  m_imageList;

  
// Attributes
protected:
  ItemLocIDMap       m_refMap;
  LocIDItemMap      m_idMap;
  ItemLocIDMap      m_itemMap;
  ItemSet           m_breakpoints;
  ItemVarMap        m_itemVarMap;

  HTREEITEM         m_prevIt;
  UINT              m_prevState;
  int               m_prevImage;
  bool              m_log;
  LRESULT OnViewUpdate(WPARAM, LPARAM);
  LRESULT OnExecuteCmd(WPARAM, LPARAM);
  LRESULT OnException(WPARAM, LPARAM);

  IntIVariablePtrMap m_idVarMap;

  CBitmap* bm_in;
  CBitmap* bm_out;
  CBitmap* bm_inout;

  HTREEITEM m_rootItem;
protected:
  void setCallLocationImage(HTREEITEM it );
  bool isBreakpoint(HTREEITEM hItem);
  void expandRecUp(HTREEITEM hmyItem );
public:

  HTREEITEM findTreeItem(const GRDI::LocationID& locID);

  HTREEITEM addTreeItem(const GRDI::LocationID& parID,
                        const GRDI::LocationID& childID,
                        const std::string& name,
                        int type = BOUNDARY);
  void addTreeItemVars(HTREEITEM treeItem,
                       const GRDI::VariableValueMap& vars);

  void addRefMap(const GRDI::LocationID& locID, const GRDI::LocationID& refID);

//  bool toggleBreakPoint(HTREEITEM hItem);
  void hideCursor();
  void markItem(const GRDI::IGRDebuggerView::FuncLocationMarkDescrVec& markLocs);
  void selectLocation(const GRDI::LocationID& markLocID);

  void  expandRoot();
  void  showVar(const CString& var);
  void  clear();
  GRDI::IVariablePtr getVariable(int id);
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SourceTxtView)
	public:
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~SourceTxtView();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


	// Generated message map functions
protected:


	//{{AFX_MSG(SourceTxtView)
	afx_msg void OnTogglebreakpoint();
	afx_msg void OnUpdateTogglebreakpoint(CCmdUI* pCmdUI);
	afx_msg void OnLog();
	afx_msg void OnUpdateLog(CCmdUI* pCmdUI);
	afx_msg void OnShowallreakpoints();
	afx_msg void OnUpdateShowallreakpoints(CCmdUI* pCmdUI);
	afx_msg void OnClearall();
	afx_msg void OnUpdateClearall(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOURCETXTVIEW_H__4340A825_DC98_4FD1_9711_23ED9BBD6E37__INCLUDED_)
