#ifndef GRThread_H
#define GRThread_H

#include "IGReAT.h"

class CGREngineDlgDlg;
class Notify : public IGReAT::ICtrlNotify
{
public:

  CGREngineDlgDlg& m_dlg;
  bool m_quit;
  bool m_cancel;
  UINT m_maxPrg;
  
public:

  Notify(CGREngineDlgDlg& dlg, UINT maxPrg ) : 
      m_dlg(dlg), 
      m_maxPrg(maxPrg),
      m_quit(false),
	  m_cancel(false) {}

  void finished();

  // IGReAT::ICtrlNotify
  void reportProgress(double prg); 
  void reportExcuteRule(const string &rule);

  bool quit()
  {
    return m_quit;
  }
};
//===================
class GRThread
{
public:

  string m_fname;
  vector<string> m_inputs;
  Notify*  m_notify;

public: 

  GRThread(const std::string& fname);

  GRThread(const std::string& fname,
           Notify* notify);

  GRThread(const std::string& fname, const vector<std::string> &inputs,
           Notify* notify);

  void operator()();
};

#endif 