#include "iostream"
//#include <atlbase.h>
//#include <comdef.h>

#include <time.h>

#include "UdmStatic.h"
#include "UdmDom.h"
#include "UdmGME.h"
#include "UmlExt.h"
#include "UdmUtil.h"

#include "MetaGME.h"
#include "LegacyUpdateVisitor.h"

//using namespace std;

bool AskUserForConstraint()
{	
	char c;
	cout << "The metamodel contains constrains.\nConstraints in MetaGME use a different syntax than those in UML.\nIf you chose to copy the constraints you will need to edit them by hand.\n\nDo you wish to copy the constraints? (Y/N)";
	cin >> c;
	if(c == 'y' || c == 'Y')
		return true;
	return false;
}

int main(int argc, char* argv[])
{	
	std::cout << "Legacy Update Utility\n(c) 2004 Institute for Integrated Systems\nVanderbilt University\n\n";
	if(argc < 2)
	{	cout << "Usage: LegacyUpdate <MetaGME filename>" << endl;
		return 0;
	}
	bool overwrite = false;

	try
	{	clock_t start,finish;
		start=clock();
		
		// Loading MetaGME file 
		UdmGme::GmeDataNetwork metaGme(MetaGME::diagram);
		metaGme.OpenExisting(argv[1],"MetaGME",Udm::CHANGES_LOST_DEFAULT);

		//Performing Update
		MetaGME::RootFolder rf = MetaGME::RootFolder::Cast(metaGme.GetRootObject());
		LegacyUpdateVisitor luv;
		luv.Visit_RootFolder(rf);

		
		metaGme.CloseWithUpdate();
		finish = clock();
		double duration = (double)(finish - start) / CLOCKS_PER_SEC;
		cout << "\nThe Transformation took " << duration << "seconds" <<endl;
	}
	catch(udm_exception &exc) 
	{

		cout<<"Exception occured: "<<exc.what()<<endl;
	}  
	catch(_com_error ce) 
	{
		cout << (string)ce.Description() << endl;		
	}

//	_getch();
	return 0;
}
