#include "iostream"
//#include <atlbase.h>
//#include <comdef.h>

#include <time.h>

#include "UdmStatic.h"
#include "UdmDom.h"
#include "UdmGME.h"
#include "UmlExt.h"
#include "UdmUtil.h"

#include "MetaGME.h"
#include "UmlGME.h"
#include "MetaGME2UML.h"
//#include "..\..\etc\GReATVersion.h"

char constraint; 
//using namespace std;

bool AskUserForConstraint(long param)
{	
	char c;
	if(param != 128)
	{	cout << "The metamodel contains constrains.\nConstraints in MetaGME use a different syntax than those in UML.\nIf you chose to copy the constraints you will need to edit them by hand.\n\nDo you wish to copy the constraints? (Y/N)";
		cin >> c;
	}
	else
	{	c = constraint;
	}
	if(c == 'y' || c == 'Y')
		return true;
	return false;
}

int main(int argc, char* argv[])
{	
	std::cout << "MetaGME to UML Converter Utility v" << UDM_VERSION_MAJOR << "." << UDM_VERSION_MINOR << "\n(c) 2004 Institute for Integrated Systems\nVanderbilt University\n\n";
	if(argc < 3)
	{	cout << "MetaGME2UML <MetaGME filename> <UML filename> [y/n]" << endl;
		return 0;
	}
	bool overwrite = false;
	if(argc >=4)
	{	constraint = argv[3][1];
	}

	try
	{	clock_t start,finish;
		start=clock();
		
		// Loading MetaGME file 
		UdmGme::GmeDataNetwork metaGme(MetaGME::diagram);
		metaGme.OpenExisting(argv[1],"MetaGME",Udm::CHANGES_LOST_DEFAULT);

		//MetaGME::RootFolder rf = MetaGME::RootFolder::Cast(metaGme.GetRootObject());
		//cout << (string)rf.name() << endl;

		// Loading UmlGME file
		Udm::SmartDataNetwork umlGme(UmlGME::diagram);
		umlGme.CreateNew(argv[2],"Uml", UmlGME::RootFolder::meta, Udm::CHANGES_LOST_DEFAULT);
		UmlGME::RootFolder rf = UmlGME::RootFolder::Cast(umlGme.GetRootObject());

		

		MetaGME2UML transformer(metaGme, umlGme, rf, 128);
		transformer.transformMetaGME2UmlGME();
		//////////////////////////////////////////////////////////////////////////////
		
		metaGme.CloseWithUpdate();
		umlGme.CloseWithUpdate();
		
		finish = clock();
		double duration = (double)(finish - start) / CLOCKS_PER_SEC;
		cout << "\nThe Transformation took " << duration << "seconds" <<endl;
	}
	catch(udm_exception &exc) 
	{

		cout<<"Exception occured: "<<exc.what()<<endl;
	}  
	catch(_com_error ce) 
	{
		cout << (string)ce.Description() << endl;		
	}

//	_getch();
	return 0;
}
