#include "umt2cfg.h"
#include <UmlExt.h>
#include <UdmUtil.h>
void UMT2Config_0::operator()( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3)
{
#ifdef PRINT_INFO
	std::cout << "UMT2Config_0" << std::endl;
#endif
	for( Packets_t::const_iterator itconfRF_6= confRFs_1.begin(), itumtConfigmodel_d= umtConfigmodels_3.begin(); itconfRF_6!= confRFs_1.end(), itumtConfigmodel_d!= umtConfigmodels_3.end(); ++itconfRF_6, ++itumtConfigmodel_d)
	{
		bool isUnique= isInputUnique( *itconfRF_6, *itumtConfigmodel_d);
		if( !isUnique)
			continue;
		Packets_t oneconfRF_a( 1, *itconfRF_6);
		Packets_t oneumtConfigmodel_11( 1, *itumtConfigmodel_d);
		executeOne( oneconfRF_a, oneumtConfigmodel_11);
	}
}

void UMT2Config_0::executeOne( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3)
{
	if( ( !confRFs_1.empty())&& ( !umtConfigmodels_3.empty()))
		callInit_1ce( confRFs_1, umtConfigmodels_3);
}

bool UMT2Config_0::isInputUnique( const Udm::Object& confRF_7, const Udm::Object& umtConfigmodel_e)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itconfRF_9= _confRF_5.begin(), itumtConfigmodel_10= _umtConfigmodel_c.begin(); itconfRF_9!= _confRF_5.end(), itumtConfigmodel_10!= _umtConfigmodel_c.end(); ++itconfRF_9, ++itumtConfigmodel_10)
	{
		if( ( *itconfRF_9== confRF_7)&& ( *itumtConfigmodel_10== umtConfigmodel_e))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_confRF_5.push_back( confRF_7);
		_umtConfigmodel_c.push_back( umtConfigmodel_e);
	}
	return isUnique;
}

void UMT2Config_0::callInit_1ce( const Packets_t& rootFolders_1ab, const Packets_t& configurations_1ae)
{
	Packets_t rootFolders_1ad;
	Packets_t configurations_1b0;
	Init_1aa init_1aa;
	init_1aa( rootFolders_1ab, configurations_1ae, rootFolders_1ad, configurations_1b0);
	if( ( !rootFolders_1ad.empty())&& ( !configurations_1b0.empty()))
		callMetaInfo_1d1( rootFolders_1ad, configurations_1b0);
}

void UMT2Config_0::callMetaInfo_1d1( const Packets_t& rootFolders_182, const Packets_t& configurations_185)
{
	Packets_t rootFolders_184;
	Packets_t configurations_187;
	MetaInfo_181 metaInfo_181;
	metaInfo_181( rootFolders_182, configurations_185, rootFolders_184, configurations_187);
	if( ( !rootFolders_184.empty())&& ( !configurations_187.empty()))
		callUsageInfo_1d4( rootFolders_184, configurations_187);
}

void UMT2Config_0::callUsageInfo_1d4( const Packets_t& confRFs_3d, const Packets_t& umtConfigmodels_3f)
{
	Packets_t outs_41;
	Packets_t outs_42;
	UsageInfo_3c usageInfo_3c;
	usageInfo_3c( confRFs_3d, umtConfigmodels_3f, outs_41, outs_42);
	if( ( !outs_42.empty())&& ( !outs_41.empty()))
		callRunTimeInfo_1d7( outs_42, outs_41);
}

void UMT2Config_0::callRunTimeInfo_1d7( const Packets_t& rootFolders_14, const Packets_t& configurations_16)
{
	RunTimeInfo_13 runTimeInfo_13;
	runTimeInfo_13( rootFolders_14, configurations_16);
}

void RunTimeInfo_13::operator()( const Packets_t& rootFolders_14, const Packets_t& configurations_16)
{
#ifdef PRINT_INFO
	std::cout << "RunTimeInfo_13" << std::endl;
#endif
	processInputPackets( rootFolders_14, configurations_16);
}

bool RunTimeInfo_13::isInputUnique( const Udm::Object& rootFolder_1c, const Udm::Object& configuration_25)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_1e= _rootFolder_18.begin(), itConfiguration_27= _configuration_21.begin(); itRootFolder_1e!= _rootFolder_18.end(), itConfiguration_27!= _configuration_21.end(); ++itRootFolder_1e, ++itConfiguration_27)
	{
		if( ( *itRootFolder_1e== rootFolder_1c)&& ( *itConfiguration_27== configuration_25))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_18.push_back( rootFolder_1c);
		_configuration_21.push_back( configuration_25);
	}
	return isUnique;
}

void RunTimeInfo_13::processInputPackets( const Packets_t& rootFolders_14, const Packets_t& configurations_16)
{
	for( Packets_t::const_iterator itRootFolder_19= rootFolders_14.begin(), itConfiguration_22= configurations_16.begin(); itRootFolder_19!= rootFolders_14.end(), itConfiguration_22!= configurations_16.end(); ++itRootFolder_19, ++itConfiguration_22)
	{
		bool isUnique= isInputUnique( *itRootFolder_19, *itConfiguration_22);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_19, *itConfiguration_22);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool RunTimeInfo_13::patternMatcher( const Udm::Object& rootFolder_1a, const Udm::Object& configuration_23)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_1a.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_1f= GReATConfig::RootFolder::Cast( rootFolder_1a);
		if( false== Uml::IsDerivedFrom( configuration_23.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_28= UMLModelTransformer::Configuration::Cast( configuration_23);
		set< UMLModelTransformer::FileType> fileTypes_2a= configuration_28.FileType_kind_children();
		for( set< UMLModelTransformer::FileType>::const_iterator itFileType_2b= fileTypes_2a.begin(); itFileType_2b!= fileTypes_2a.end(); ++itFileType_2b)
		{
			UMLModelTransformer::FileType currFileType_2c= *itFileType_2b;
			set< GReATConfig::RuntimeInformation> runtimeInformations_2d= rootFolder_1f.RuntimeInformation_kind_children();
			for( set< GReATConfig::RuntimeInformation>::const_iterator itRuntimeInformation_2e= runtimeInformations_2d.begin(); itRuntimeInformation_2e!= runtimeInformations_2d.end(); ++itRuntimeInformation_2e)
			{
				GReATConfig::RuntimeInformation currRuntimeInformation_2f= *itRuntimeInformation_2e;
				set< UMLModelTransformer::FileBind> fileBinds_30= currFileType_2c.srcFileBind();
				for( set< UMLModelTransformer::FileBind>::const_iterator itFileBinds_31= fileBinds_30.begin(); itFileBinds_31!= fileBinds_30.end(); ++itFileBinds_31)
				{
					UMLModelTransformer::FileBind currFileBindPseudo_32_33= *itFileBinds_31;
					UMLModelTransformer::File file_34= currFileBindPseudo_32_33.srcFileBind_end();
					Match currMatch;
					currMatch.rootFolder_35= rootFolder_1f;
					currMatch.configuration_36= configuration_28;
					currMatch.fileType_37= currFileType_2c;
					currMatch.runtimeInformation_38= currRuntimeInformation_2f;
					currMatch.file_39= file_34;
					currMatch.fileBindPseudo_32_3a= currFileBindPseudo_32_33;
					_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void RunTimeInfo_13::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::InputFile newInputFile_3b= GReATConfig::InputFile::Create( currMatch.runtimeInformation_38);
		UMLModelTransformer::Configuration& Configuration= currMatch.configuration_36;
		UMLModelTransformer::File& File= currMatch.file_39;
		UMLModelTransformer::FileBind& FileBindPseudo_32= currMatch.fileBindPseudo_32_3a;
		UMLModelTransformer::FileType& FileType= currMatch.fileType_37;
		GReATConfig::InputFile& InputFile= newInputFile_3b;
		GReATConfig::RootFolder& RootFolder= currMatch.rootFolder_35;
		GReATConfig::RuntimeInformation& RuntimeInformation= currMatch.runtimeInformation_38;
		{cint_string t1(1024); File.GetStrVal("FilePathName",t1); InputFile.SetStrVal("FileName",t1); File.GetStrVal("CopyPathName",t1); InputFile.SetStrVal("CopyName",t1); FileType.GetStrVal("name",t1); InputFile.SetStrVal("FileID",t1); InputFile.SetStrVal("name",t1);};
		outputAppender( );
	}
}

void RunTimeInfo_13::outputAppender()
{
}

void UsageInfo_3c::operator()( const Packets_t& confRFs_3d, const Packets_t& umtConfigmodels_3f, Packets_t& outs_41, Packets_t& outs_42)
{
#ifdef PRINT_INFO
	std::cout << "UsageInfo_3c" << std::endl;
#endif
	_out_43= &outs_41;
	_out_44= &outs_42;
	if( ( !confRFs_3d.empty())&& ( !umtConfigmodels_3f.empty()))
		callUsageInfo_175( confRFs_3d, umtConfigmodels_3f);
	_out_44->insert( _out_44->end(), confRFs_3d.begin(), confRFs_3d.end());
	_out_43->insert( _out_43->end(), umtConfigmodels_3f.begin(), umtConfigmodels_3f.end());
}

void UsageInfo_3c::callUsageInfo_175( const Packets_t& rootFolders_46, const Packets_t& configurations_48)
{
	Packets_t configurations_4a;
	Packets_t uIs_4b;
	Packets_t expressions_4c;
	UsageInfo_45 usageInfo_45;
	usageInfo_45( rootFolders_46, configurations_48, configurations_4a, uIs_4b, expressions_4c);
	if( ( !expressions_4c.empty())&& ( !uIs_4b.empty()))
		callGetPath_178( expressions_4c, uIs_4b);
	if( ( !uIs_4b.empty())&& ( !configurations_4a.empty()))
		callUsagefile_17b( uIs_4b, configurations_4a);
}

void UsageInfo_3c::callGetPath_178( const Packets_t& ins_75, const Packets_t& ins_77)
{
	GetPath_74 getPath_74;
	getPath_74( ins_75, ins_77);
}

void UsageInfo_3c::callUsagefile_17b( const Packets_t& usageInformations_124, const Packets_t& configurations_127)
{
	Packets_t usageInformations_126;
	Packets_t fileTypes_129;
	Usagefile_123 usagefile_123;
	usagefile_123( usageInformations_124, configurations_127, usageInformations_126, fileTypes_129);
	if( ( !usageInformations_126.empty())&& ( !fileTypes_129.empty()))
		callTransformationInput_17e( usageInformations_126, fileTypes_129);
}

void UsageInfo_3c::callTransformationInput_17e( const Packets_t& usageInformations_14a, const Packets_t& fileTypes_14c)
{
	TransformationInput_149 transformationInput_149;
	transformationInput_149( usageInformations_14a, fileTypes_14c);
}

void UsageInfo_45::operator()( const Packets_t& rootFolders_46, const Packets_t& configurations_48, Packets_t& configurations_4a, Packets_t& uIs_4b, Packets_t& expressions_4c)
{
#ifdef PRINT_INFO
	std::cout << "UsageInfo_45" << std::endl;
#endif
	_configuration_4d= &configurations_4a;
	_uI_4e= &uIs_4b;
	_expression_4f= &expressions_4c;
	processInputPackets( rootFolders_46, configurations_48);
}

bool UsageInfo_45::isInputUnique( const Udm::Object& rootFolder_54, const Udm::Object& configuration_5d)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_56= _rootFolder_50.begin(), itConfiguration_5f= _configuration_59.begin(); itRootFolder_56!= _rootFolder_50.end(), itConfiguration_5f!= _configuration_59.end(); ++itRootFolder_56, ++itConfiguration_5f)
	{
		if( ( *itRootFolder_56== rootFolder_54)&& ( *itConfiguration_5f== configuration_5d))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_50.push_back( rootFolder_54);
		_configuration_59.push_back( configuration_5d);
	}
	return isUnique;
}

void UsageInfo_45::processInputPackets( const Packets_t& rootFolders_46, const Packets_t& configurations_48)
{
	for( Packets_t::const_iterator itRootFolder_51= rootFolders_46.begin(), itConfiguration_5a= configurations_48.begin(); itRootFolder_51!= rootFolders_46.end(), itConfiguration_5a!= configurations_48.end(); ++itRootFolder_51, ++itConfiguration_5a)
	{
		bool isUnique= isInputUnique( *itRootFolder_51, *itConfiguration_5a);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_51, *itConfiguration_5a);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool UsageInfo_45::patternMatcher( const Udm::Object& rootFolder_52, const Udm::Object& configuration_5b)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_52.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_57= GReATConfig::RootFolder::Cast( rootFolder_52);
		if( false== Uml::IsDerivedFrom( configuration_5b.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_60= UMLModelTransformer::Configuration::Cast( configuration_5b);
		set< GReATConfig::UsageInformation> uIs_62= rootFolder_57.UsageInformation_kind_children();
		for( set< GReATConfig::UsageInformation>::const_iterator itUI_63= uIs_62.begin(); itUI_63!= uIs_62.end(); ++itUI_63)
		{
			GReATConfig::UsageInformation currUI_64= *itUI_63;
			set< UMLModelTransformer::StartRule> startRules_65= configuration_60.StartRule_kind_children();
			for( set< UMLModelTransformer::StartRule>::const_iterator itStartRule_66= startRules_65.begin(); itStartRule_66!= startRules_65.end(); ++itStartRule_66)
			{
				UMLModelTransformer::StartRule currStartRule_67= *itStartRule_66;
				UMLModelTransformer::Expression expression_68= currStartRule_67.ref();
				if( !expression_68)
					continue;
				Match currMatch;
				currMatch.rootFolder_69= rootFolder_57;
				currMatch.configuration_6a= configuration_60;
				currMatch.uI_6b= currUI_64;
				currMatch.startRule_6c= currStartRule_67;
				currMatch.expression_6d= expression_68;
				_matches.push_back( currMatch);
			}
		}
	}
	return !_matches.empty();
}

void UsageInfo_45::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		UMLModelTransformer::Configuration& Configuration= currMatch.configuration_6a;
		UMLModelTransformer::Expression& Expression= currMatch.expression_6d;
		GReATConfig::RootFolder& RootFolder= currMatch.rootFolder_69;
		UMLModelTransformer::StartRule& StartRule= currMatch.startRule_6c;
		GReATConfig::UsageInformation& UI= currMatch.uI_6b;
		{cint_string t1(255); Expression.GetStrVal("name", t1); UI.SetStrVal("StartRulePath",t1); };
		outputAppender( currMatch.configuration_6a, currMatch.uI_6b, currMatch.expression_6d);
	}
}

void UsageInfo_45::outputAppender( const UMLModelTransformer::Configuration& configuration_6e, const GReATConfig::UsageInformation& uI_70, const UMLModelTransformer::Expression& expression_72)
{
	_configuration_4d->push_back( configuration_6e);
	_uI_4e->push_back( uI_70);
	_expression_4f->push_back( expression_72);
}

void GetPath_74::operator()( const Packets_t& ins_75, const Packets_t& ins_77)
{
#ifdef PRINT_INFO
	std::cout << "GetPath_74" << std::endl;
#endif
	if( ( !ins_75.empty())&& ( !ins_77.empty()))
		callTest_11d( ins_75, ins_77);
}

void GetPath_74::callTest_11d( const Packets_t& ins_7a, const Packets_t& ins_7c)
{
	Packets_t outs_7e;
	Packets_t outs_7f;
	Test_79 test_79;
	test_79( ins_7a, ins_7c, outs_7e, outs_7f);
	if( ( !outs_7f.empty())&& ( !outs_7e.empty()))
		callStartRulePath_120( outs_7f, outs_7e);
}

void GetPath_74::callStartRulePath_120( const Packets_t& parents_fd, const Packets_t& uIs_100)
{
	Packets_t parents_ff;
	Packets_t uIs_102;
	StartRulePath_fc startRulePath_fc;
	startRulePath_fc( parents_fd, uIs_100, parents_ff, uIs_102);
	if( ( !parents_ff.empty())&& ( !uIs_102.empty()))
		callTest_11d( parents_ff, uIs_102);
}

void Test_79::operator()( const Packets_t& ins_7a, const Packets_t& ins_7c, Packets_t& outs_7e, Packets_t& outs_7f)
{
#ifdef PRINT_INFO
	std::cout << "Test_79" << std::endl;
#endif
	_out_80= &outs_7e;
	_out_81= &outs_7f;
	for( Packets_t::const_iterator itIn_83= ins_7a.begin(), itIn_8a= ins_7c.begin(); itIn_83!= ins_7a.end(), itIn_8a!= ins_7c.end(); ++itIn_83, ++itIn_8a)
	{
		bool isUnique= isInputUnique( *itIn_83, *itIn_8a);
		if( !isUnique)
			continue;
		Packets_t oneIn_87( 1, *itIn_83);
		Packets_t oneIn_8e( 1, *itIn_8a);
		executeOne( oneIn_87, oneIn_8e);
	}
}

void Test_79::executeOne( const Packets_t& ins_7a, const Packets_t& ins_7c)
{
	Packets_t uIs_95;
	Packets_t parents_96;
	RuleCompound_90 ruleCompound_90;
	bool isMatchRuleCompound_90= ruleCompound_90( ins_7a, ins_7c, uIs_95, parents_96);
	_out_80->insert( _out_80->end(), uIs_95.begin(), uIs_95.end());
	_out_81->insert( _out_81->end(), parents_96.begin(), parents_96.end());
	if( isMatchRuleCompound_90)
		return;
	Packets_t uIs_b9;
	Packets_t parents_ba;
	TestCompound_b4 testCompound_b4;
	bool isMatchTestCompound_b4= testCompound_b4( ins_7a, ins_7c, uIs_b9, parents_ba);
	_out_80->insert( _out_80->end(), uIs_b9.begin(), uIs_b9.end());
	_out_81->insert( _out_81->end(), parents_ba.begin(), parents_ba.end());
	if( isMatchTestCompound_b4)
		return;
	Packets_t uIs_dd;
	Packets_t parents_de;
	CompoundCompound_d8 compoundCompound_d8;
	bool isMatchCompoundCompound_d8= compoundCompound_d8( ins_7a, ins_7c, uIs_dd, parents_de);
	_out_80->insert( _out_80->end(), uIs_dd.begin(), uIs_dd.end());
	_out_81->insert( _out_81->end(), parents_de.begin(), parents_de.end());
	if( isMatchCompoundCompound_d8)
		return;
}

bool Test_79::isInputUnique( const Udm::Object& in_84, const Udm::Object& in_8b)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itIn_86= _in_82.begin(), itIn_8d= _in_89.begin(); itIn_86!= _in_82.end(), itIn_8d!= _in_89.end(); ++itIn_86, ++itIn_8d)
	{
		if( ( *itIn_86== in_84)&& ( *itIn_8d== in_8b))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_in_82.push_back( in_84);
		_in_89.push_back( in_8b);
	}
	return isUnique;
}

bool RuleCompound_90::operator()( const Packets_t& childs_91, const Packets_t& uIs_93, Packets_t& uIs_95, Packets_t& parents_96)
{
#ifdef PRINT_INFO
	std::cout << "RuleCompound_90" << std::endl;
#endif
	_uI_97= &uIs_95;
	_parent_98= &parents_96;
	processInputPackets( childs_91, uIs_93);
	if( false== _matches.empty())
		return true;
	return false;
}

bool RuleCompound_90::isInputUnique( const Udm::Object& child_9d, const Udm::Object& uI_a6)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itChild_9f= _child_99.begin(), itUI_a8= _uI_a2.begin(); itChild_9f!= _child_99.end(), itUI_a8!= _uI_a2.end(); ++itChild_9f, ++itUI_a8)
	{
		if( ( *itChild_9f== child_9d)&& ( *itUI_a8== uI_a6))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_child_99.push_back( child_9d);
		_uI_a2.push_back( uI_a6);
	}
	return isUnique;
}

void RuleCompound_90::processInputPackets( const Packets_t& childs_91, const Packets_t& uIs_93)
{
	for( Packets_t::const_iterator itChild_9a= childs_91.begin(), itUI_a3= uIs_93.begin(); itChild_9a!= childs_91.end(), itUI_a3!= uIs_93.end(); ++itChild_9a, ++itUI_a3)
	{
		bool isUnique= isInputUnique( *itChild_9a, *itUI_a3);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itChild_9a, *itUI_a3);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.uI_ae, currMatch.parent_af);
	}
}

bool RuleCompound_90::patternMatcher( const Udm::Object& child_9b, const Udm::Object& uI_a4)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( child_9b.type(), UMLModelTransformer::Rule::meta))
			continue;
		UMLModelTransformer::Rule child_a0= UMLModelTransformer::Rule::Cast( child_9b);
		if( false== Uml::IsDerivedFrom( uI_a4.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_a9= GReATConfig::UsageInformation::Cast( uI_a4);
		Udm::Object childParent_ab= child_a0.container();
		if( false== Uml::IsDerivedFrom( childParent_ab.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule parentChild_ac= UMLModelTransformer::CompoundRule::Cast( childParent_ab);
		Match currMatch;
		currMatch.child_ad= child_a0;
		currMatch.uI_ae= uI_a9;
		currMatch.parent_af= parentChild_ac;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void RuleCompound_90::outputAppender( const GReATConfig::UsageInformation& uI_b0, const UMLModelTransformer::CompoundRule& parent_b2)
{
	_uI_97->push_back( uI_b0);
	_parent_98->push_back( parent_b2);
}

bool TestCompound_b4::operator()( const Packets_t& childs_b5, const Packets_t& uIs_b7, Packets_t& uIs_b9, Packets_t& parents_ba)
{
#ifdef PRINT_INFO
	std::cout << "TestCompound_b4" << std::endl;
#endif
	_uI_bb= &uIs_b9;
	_parent_bc= &parents_ba;
	processInputPackets( childs_b5, uIs_b7);
	if( false== _matches.empty())
		return true;
	return false;
}

bool TestCompound_b4::isInputUnique( const Udm::Object& child_c1, const Udm::Object& uI_ca)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itChild_c3= _child_bd.begin(), itUI_cc= _uI_c6.begin(); itChild_c3!= _child_bd.end(), itUI_cc!= _uI_c6.end(); ++itChild_c3, ++itUI_cc)
	{
		if( ( *itChild_c3== child_c1)&& ( *itUI_cc== uI_ca))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_child_bd.push_back( child_c1);
		_uI_c6.push_back( uI_ca);
	}
	return isUnique;
}

void TestCompound_b4::processInputPackets( const Packets_t& childs_b5, const Packets_t& uIs_b7)
{
	for( Packets_t::const_iterator itChild_be= childs_b5.begin(), itUI_c7= uIs_b7.begin(); itChild_be!= childs_b5.end(), itUI_c7!= uIs_b7.end(); ++itChild_be, ++itUI_c7)
	{
		bool isUnique= isInputUnique( *itChild_be, *itUI_c7);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itChild_be, *itUI_c7);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.uI_d2, currMatch.parent_d3);
	}
}

bool TestCompound_b4::patternMatcher( const Udm::Object& child_bf, const Udm::Object& uI_c8)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( child_bf.type(), UMLModelTransformer::Test::meta))
			continue;
		UMLModelTransformer::Test child_c4= UMLModelTransformer::Test::Cast( child_bf);
		if( false== Uml::IsDerivedFrom( uI_c8.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_cd= GReATConfig::UsageInformation::Cast( uI_c8);
		Udm::Object childParent_cf= child_c4.container();
		if( false== Uml::IsDerivedFrom( childParent_cf.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule parentChild_d0= UMLModelTransformer::CompoundRule::Cast( childParent_cf);
		Match currMatch;
		currMatch.child_d1= child_c4;
		currMatch.uI_d2= uI_cd;
		currMatch.parent_d3= parentChild_d0;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void TestCompound_b4::outputAppender( const GReATConfig::UsageInformation& uI_d4, const UMLModelTransformer::CompoundRule& parent_d6)
{
	_uI_bb->push_back( uI_d4);
	_parent_bc->push_back( parent_d6);
}

bool CompoundCompound_d8::operator()( const Packets_t& childs_d9, const Packets_t& uIs_db, Packets_t& uIs_dd, Packets_t& parents_de)
{
#ifdef PRINT_INFO
	std::cout << "CompoundCompound_d8" << std::endl;
#endif
	_uI_df= &uIs_dd;
	_parent_e0= &parents_de;
	processInputPackets( childs_d9, uIs_db);
	if( false== _matches.empty())
		return true;
	return false;
}

bool CompoundCompound_d8::isInputUnique( const Udm::Object& child_e5, const Udm::Object& uI_ee)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itChild_e7= _child_e1.begin(), itUI_f0= _uI_ea.begin(); itChild_e7!= _child_e1.end(), itUI_f0!= _uI_ea.end(); ++itChild_e7, ++itUI_f0)
	{
		if( ( *itChild_e7== child_e5)&& ( *itUI_f0== uI_ee))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_child_e1.push_back( child_e5);
		_uI_ea.push_back( uI_ee);
	}
	return isUnique;
}

void CompoundCompound_d8::processInputPackets( const Packets_t& childs_d9, const Packets_t& uIs_db)
{
	for( Packets_t::const_iterator itChild_e2= childs_d9.begin(), itUI_eb= uIs_db.begin(); itChild_e2!= childs_d9.end(), itUI_eb!= uIs_db.end(); ++itChild_e2, ++itUI_eb)
	{
		bool isUnique= isInputUnique( *itChild_e2, *itUI_eb);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itChild_e2, *itUI_eb);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.uI_f6, currMatch.parent_f7);
	}
}

bool CompoundCompound_d8::patternMatcher( const Udm::Object& child_e3, const Udm::Object& uI_ec)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( child_e3.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule child_e8= UMLModelTransformer::CompoundRule::Cast( child_e3);
		if( false== Uml::IsDerivedFrom( uI_ec.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_f1= GReATConfig::UsageInformation::Cast( uI_ec);
		Udm::Object childParent_f3= child_e8.container();
		if( false== Uml::IsDerivedFrom( childParent_f3.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule parentChild_f4= UMLModelTransformer::CompoundRule::Cast( childParent_f3);
		Match currMatch;
		currMatch.child_f5= child_e8;
		currMatch.uI_f6= uI_f1;
		currMatch.parent_f7= parentChild_f4;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void CompoundCompound_d8::outputAppender( const GReATConfig::UsageInformation& uI_f8, const UMLModelTransformer::CompoundRule& parent_fa)
{
	_uI_df->push_back( uI_f8);
	_parent_e0->push_back( parent_fa);
}

void StartRulePath_fc::operator()( const Packets_t& parents_fd, const Packets_t& uIs_100, Packets_t& parents_ff, Packets_t& uIs_102)
{
#ifdef PRINT_INFO
	std::cout << "StartRulePath_fc" << std::endl;
#endif
	_parent_103= &parents_ff;
	_uI_104= &uIs_102;
	processInputPackets( parents_fd, uIs_100);
	forwardInputs( );
}

bool StartRulePath_fc::isInputUnique( const Udm::Object& parent_109, const Udm::Object& uI_112)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itParent_10b= _parent_105.begin(), itUI_114= _uI_10e.begin(); itParent_10b!= _parent_105.end(), itUI_114!= _uI_10e.end(); ++itParent_10b, ++itUI_114)
	{
		if( ( *itParent_10b== parent_109)&& ( *itUI_114== uI_112))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_parent_105.push_back( parent_109);
		_uI_10e.push_back( uI_112);
	}
	return isUnique;
}

void StartRulePath_fc::processInputPackets( const Packets_t& parents_fd, const Packets_t& uIs_100)
{
	for( Packets_t::const_iterator itParent_106= parents_fd.begin(), itUI_10f= uIs_100.begin(); itParent_106!= parents_fd.end(), itUI_10f!= uIs_100.end(); ++itParent_106, ++itUI_10f)
	{
		bool isUnique= isInputUnique( *itParent_106, *itUI_10f);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itParent_106, *itUI_10f);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool StartRulePath_fc::patternMatcher( const Udm::Object& parent_107, const Udm::Object& uI_110)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( parent_107.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression parent_10c= UMLModelTransformer::Expression::Cast( parent_107);
		if( false== Uml::IsDerivedFrom( uI_110.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_115= GReATConfig::UsageInformation::Cast( uI_110);
		Match currMatch;
		currMatch.parent_117= parent_10c;
		currMatch.uI_118= uI_115;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void StartRulePath_fc::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		UMLModelTransformer::Expression& Parent= currMatch.parent_117;
		GReATConfig::UsageInformation& UI= currMatch.uI_118;
		{cint_string t1(1024), t2(1024); Parent.GetStrVal("name",t1); UI.GetStrVal("StartRulePath",t2); t1 += ";"; t1 += t2; UI.SetStrVal("StartRulePath",t1);};
		outputAppender( currMatch.parent_117, currMatch.uI_118);
	}
}

void StartRulePath_fc::outputAppender( const UMLModelTransformer::Expression& parent_119, const GReATConfig::UsageInformation& uI_11b)
{
	_parent_103->push_back( parent_119);
	_uI_104->push_back( uI_11b);
}

void StartRulePath_fc::forwardInputs()
{
	*_parent_103= _parent_105;
	*_uI_104= _uI_10e;
}

void Usagefile_123::operator()( const Packets_t& usageInformations_124, const Packets_t& configurations_127, Packets_t& usageInformations_126, Packets_t& fileTypes_129)
{
#ifdef PRINT_INFO
	std::cout << "Usagefile_123" << std::endl;
#endif
	_usageInformation_12a= &usageInformations_126;
	_fileType_12b= &fileTypes_129;
	processInputPackets( usageInformations_124, configurations_127);
}

bool Usagefile_123::isInputUnique( const Udm::Object& usageInformation_130, const Udm::Object& configuration_139)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itUsageInformation_132= _usageInformation_12c.begin(), itConfiguration_13b= _configuration_135.begin(); itUsageInformation_132!= _usageInformation_12c.end(), itConfiguration_13b!= _configuration_135.end(); ++itUsageInformation_132, ++itConfiguration_13b)
	{
		if( ( *itUsageInformation_132== usageInformation_130)&& ( *itConfiguration_13b== configuration_139))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_usageInformation_12c.push_back( usageInformation_130);
		_configuration_135.push_back( configuration_139);
	}
	return isUnique;
}

void Usagefile_123::processInputPackets( const Packets_t& usageInformations_124, const Packets_t& configurations_127)
{
	for( Packets_t::const_iterator itUsageInformation_12d= usageInformations_124.begin(), itConfiguration_136= configurations_127.begin(); itUsageInformation_12d!= usageInformations_124.end(), itConfiguration_136!= configurations_127.end(); ++itUsageInformation_12d, ++itConfiguration_136)
	{
		bool isUnique= isInputUnique( *itUsageInformation_12d, *itConfiguration_136);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itUsageInformation_12d, *itConfiguration_136);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool Usagefile_123::patternMatcher( const Udm::Object& usageInformation_12e, const Udm::Object& configuration_137)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( usageInformation_12e.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation usageInformation_133= GReATConfig::UsageInformation::Cast( usageInformation_12e);
		if( false== Uml::IsDerivedFrom( configuration_137.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_13c= UMLModelTransformer::Configuration::Cast( configuration_137);
		set< UMLModelTransformer::FileType> fileTypes_13e= configuration_13c.FileType_kind_children();
		for( set< UMLModelTransformer::FileType>::const_iterator itFileType_13f= fileTypes_13e.begin(); itFileType_13f!= fileTypes_13e.end(); ++itFileType_13f)
		{
			UMLModelTransformer::FileType currFileType_140= *itFileType_13f;
			Match currMatch;
			currMatch.usageInformation_141= usageInformation_133;
			currMatch.configuration_142= configuration_13c;
			currMatch.fileType_143= currFileType_140;
			_matches.push_back( currMatch);
		}
	}
	return !_matches.empty();
}

void Usagefile_123::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::FileUsage newFileUsage_144= GReATConfig::FileUsage::Create( currMatch.usageInformation_141);
		UMLModelTransformer::Configuration& Configuration= currMatch.configuration_142;
		UMLModelTransformer::FileType& FileType= currMatch.fileType_143;
		GReATConfig::FileUsage& FileUsage= newFileUsage_144;
		GReATConfig::UsageInformation& UsageInformation= currMatch.usageInformation_141;
		{bool runMem= false; FileType.GetBoolVal("RunInMemory",runMem); FileUsage.SetBoolVal("RunInMemory", runMem); cint_string t1(255); FileType.GetStrVal("MetaName", t1); FileUsage.SetStrVal("MetaName", t1); FileType.GetStrVal("RootClassName", t1); FileUsage.SetStrVal("RootClassName", t1); FileType.GetStrVal("DtdFilePath", t1); FileUsage.SetStrVal("DTDFileName", t1); FileType.GetStrVal("name", t1); FileUsage.SetStrVal("FileID", t1); FileUsage.SetStrVal("name", t1); FileType.GetStrVal("Mode", t1); if(t1.comp("read")==0) {   FileUsage.SetStrVal("Mode","r"); } else if(t1.comp("write")==0) {   FileUsage.SetStrVal("Mode", "w"); } else if(t1.comp("read and write")==0) {   FileUsage.SetStrVal("Mode", "rw"); } else if(t1.comp("read and write to a copy")==0) {   FileUsage.SetStrVal("Mode", "rwc"); }};
		outputAppender( currMatch.usageInformation_141, currMatch.fileType_143);
	}
}

void Usagefile_123::outputAppender( const GReATConfig::UsageInformation& usageInformation_145, const UMLModelTransformer::FileType& fileType_147)
{
	_usageInformation_12a->push_back( usageInformation_145);
	_fileType_12b->push_back( fileType_147);
}

void TransformationInput_149::operator()( const Packets_t& usageInformations_14a, const Packets_t& fileTypes_14c)
{
#ifdef PRINT_INFO
	std::cout << "TransformationInput_149" << std::endl;
#endif
	processInputPackets( usageInformations_14a, fileTypes_14c);
}

bool TransformationInput_149::isInputUnique( const Udm::Object& usageInformation_152, const Udm::Object& fileType_15b)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itUsageInformation_154= _usageInformation_14e.begin(), itFileType_15d= _fileType_157.begin(); itUsageInformation_154!= _usageInformation_14e.end(), itFileType_15d!= _fileType_157.end(); ++itUsageInformation_154, ++itFileType_15d)
	{
		if( ( *itUsageInformation_154== usageInformation_152)&& ( *itFileType_15d== fileType_15b))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_usageInformation_14e.push_back( usageInformation_152);
		_fileType_157.push_back( fileType_15b);
	}
	return isUnique;
}

void TransformationInput_149::processInputPackets( const Packets_t& usageInformations_14a, const Packets_t& fileTypes_14c)
{
	for( Packets_t::const_iterator itUsageInformation_14f= usageInformations_14a.begin(), itFileType_158= fileTypes_14c.begin(); itUsageInformation_14f!= usageInformations_14a.end(), itFileType_158!= fileTypes_14c.end(); ++itUsageInformation_14f, ++itFileType_158)
	{
		bool isUnique= isInputUnique( *itUsageInformation_14f, *itFileType_158);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itUsageInformation_14f, *itFileType_158);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool TransformationInput_149::patternMatcher( const Udm::Object& usageInformation_150, const Udm::Object& fileType_159)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( usageInformation_150.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation usageInformation_155= GReATConfig::UsageInformation::Cast( usageInformation_150);
		if( false== Uml::IsDerivedFrom( fileType_159.type(), UMLModelTransformer::FileType::meta))
			continue;
		UMLModelTransformer::FileType fileType_15e= UMLModelTransformer::FileType::Cast( fileType_159);
		set< UMLModelTransformer::FileObject> bObjects_160= fileType_15e.FileObject_kind_children();
		for( set< UMLModelTransformer::FileObject>::const_iterator itBObject_161= bObjects_160.begin(); itBObject_161!= bObjects_160.end(); ++itBObject_161)
		{
			UMLModelTransformer::FileObject currBObject_162= *itBObject_161;
			set< UMLModelTransformer::TransformationInput> transformationInputs_163= currBObject_162.dstTransformationInput();
			for( set< UMLModelTransformer::TransformationInput>::const_iterator itTransformationInputs_164= transformationInputs_163.begin(); itTransformationInputs_164!= transformationInputs_163.end(); ++itTransformationInputs_164)
			{
				UMLModelTransformer::TransformationInput currTransformationInputPseudo_165_166= *itTransformationInputs_164;
				UMLModelTransformer::In in_167= currTransformationInputPseudo_165_166.dstTransformationInput_end();
				Udm::Object inParent_168= in_167.container();
				if( false== Uml::IsDerivedFrom( inParent_168.type(), UMLModelTransformer::Expression::meta))
					continue;
				UMLModelTransformer::Expression expressionIn_169= UMLModelTransformer::Expression::Cast( inParent_168);
				set< UMLModelTransformer::StartRule> startRules_16a= expressionIn_169.referedbyStartRule();
				for( set< UMLModelTransformer::StartRule>::const_iterator itStartRules_16b= startRules_16a.begin(); itStartRules_16b!= startRules_16a.end(); ++itStartRules_16b)
				{
					UMLModelTransformer::StartRule currStartRule_16c= *itStartRules_16b;
					Match currMatch;
					currMatch.startRule_16d= currStartRule_16c;
					currMatch.usageInformation_16e= usageInformation_155;
					currMatch.fileType_16f= fileType_15e;
					currMatch.expression_170= expressionIn_169;
					currMatch.bObject_171= currBObject_162;
					currMatch.in_172= in_167;
					currMatch.transformationInputPseudo_165_173= currTransformationInputPseudo_165_166;
					_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void TransformationInput_149::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::TransformationInput newTransformationInput_174= GReATConfig::TransformationInput::Create( currMatch.usageInformation_16e);
		UMLModelTransformer::FileObject& BObject= currMatch.bObject_171;
		UMLModelTransformer::Expression& Expression= currMatch.expression_170;
		UMLModelTransformer::FileType& FileType= currMatch.fileType_16f;
		UMLModelTransformer::In& In= currMatch.in_172;
		UMLModelTransformer::StartRule& StartRule= currMatch.startRule_16d;
		GReATConfig::TransformationInput& TransformationInput= newTransformationInput_174;
		UMLModelTransformer::TransformationInput& TransformationInputPseudo_165= currMatch.transformationInputPseudo_165_173;
		GReATConfig::UsageInformation& UsageInformation= currMatch.usageInformation_16e;
		{cint_string t1(255); In.GetStrVal("name", t1); TransformationInput.SetStrVal("PortName", t1); BObject.GetStrVal("ObjectPath", t1); TransformationInput.SetStrVal("ObjectPath", t1); FileType.GetStrVal("name", t1); TransformationInput.SetStrVal("FileID", t1); t1 += "_PortMapping"; TransformationInput.SetStrVal("name", t1);};
		outputAppender( );
	}
}

void TransformationInput_149::outputAppender()
{
}

void MetaInfo_181::operator()( const Packets_t& rootFolders_182, const Packets_t& configurations_185, Packets_t& rootFolders_184, Packets_t& configurations_187)
{
#ifdef PRINT_INFO
	std::cout << "MetaInfo_181" << std::endl;
#endif
	_rootFolder_188= &rootFolders_184;
	_configuration_189= &configurations_187;
	processInputPackets( rootFolders_182, configurations_185);
	forwardInputs( );
}

bool MetaInfo_181::isInputUnique( const Udm::Object& rootFolder_18e, const Udm::Object& configuration_197)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_190= _rootFolder_18a.begin(), itConfiguration_199= _configuration_193.begin(); itRootFolder_190!= _rootFolder_18a.end(), itConfiguration_199!= _configuration_193.end(); ++itRootFolder_190, ++itConfiguration_199)
	{
		if( ( *itRootFolder_190== rootFolder_18e)&& ( *itConfiguration_199== configuration_197))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_18a.push_back( rootFolder_18e);
		_configuration_193.push_back( configuration_197);
	}
	return isUnique;
}

void MetaInfo_181::processInputPackets( const Packets_t& rootFolders_182, const Packets_t& configurations_185)
{
	for( Packets_t::const_iterator itRootFolder_18b= rootFolders_182.begin(), itConfiguration_194= configurations_185.begin(); itRootFolder_18b!= rootFolders_182.end(), itConfiguration_194!= configurations_185.end(); ++itRootFolder_18b, ++itConfiguration_194)
	{
		bool isUnique= isInputUnique( *itRootFolder_18b, *itConfiguration_194);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_18b, *itConfiguration_194);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool MetaInfo_181::patternMatcher( const Udm::Object& rootFolder_18c, const Udm::Object& configuration_195)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_18c.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_191= GReATConfig::RootFolder::Cast( rootFolder_18c);
		if( false== Uml::IsDerivedFrom( configuration_195.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_19a= UMLModelTransformer::Configuration::Cast( configuration_195);
		set< GReATConfig::MetaInformation> cMIFs_19c= rootFolder_191.MetaInformation_kind_children();
		for( set< GReATConfig::MetaInformation>::const_iterator itCMIF_19d= cMIFs_19c.begin(); itCMIF_19d!= cMIFs_19c.end(); ++itCMIF_19d)
		{
			GReATConfig::MetaInformation currCMIF_19e= *itCMIF_19d;
			set< UMLModelTransformer::MetaInformation> mIFs_19f= configuration_19a.MetaInformation_kind_children();
			for( set< UMLModelTransformer::MetaInformation>::const_iterator itMIF_1a0= mIFs_19f.begin(); itMIF_1a0!= mIFs_19f.end(); ++itMIF_1a0)
			{
				UMLModelTransformer::MetaInformation currMIF_1a1= *itMIF_1a0;
				Match currMatch;
				currMatch.rootFolder_1a2= rootFolder_191;
				currMatch.configuration_1a3= configuration_19a;
				currMatch.mIF_1a4= currMIF_1a1;
				currMatch.cMIF_1a5= currCMIF_19e;
				_matches.push_back( currMatch);
			}
		}
	}
	return !_matches.empty();
}

void MetaInfo_181::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::MetaInformation& CMIF= currMatch.cMIF_1a5;
		UMLModelTransformer::Configuration& Configuration= currMatch.configuration_1a3;
		UMLModelTransformer::MetaInformation& MIF= currMatch.mIF_1a4;
		GReATConfig::RootFolder& RootFolder= currMatch.rootFolder_1a2;
		{cint_string t1(1024); MIF.GetStrVal("TransformationFile",t1); CMIF.SetStrVal("TransformationFile",t1); MIF.GetStrVal("UdmProjectFile",t1); CMIF.SetStrVal("UdmProjectFile",t1); Configuration.GetStrVal("AMLinking",t1); CMIF.SetStrVal("MetaCodeGen",t1);};
		outputAppender( currMatch.rootFolder_1a2, currMatch.configuration_1a3);
	}
}

void MetaInfo_181::outputAppender( const GReATConfig::RootFolder& rootFolder_1a6, const UMLModelTransformer::Configuration& configuration_1a8)
{
	_rootFolder_188->push_back( rootFolder_1a6);
	_configuration_189->push_back( configuration_1a8);
}

void MetaInfo_181::forwardInputs()
{
	*_rootFolder_188= _rootFolder_18a;
	*_configuration_189= _configuration_193;
}

void Init_1aa::operator()( const Packets_t& rootFolders_1ab, const Packets_t& configurations_1ae, Packets_t& rootFolders_1ad, Packets_t& configurations_1b0)
{
#ifdef PRINT_INFO
	std::cout << "Init_1aa" << std::endl;
#endif
	_rootFolder_1b1= &rootFolders_1ad;
	_configuration_1b2= &configurations_1b0;
	processInputPackets( rootFolders_1ab, configurations_1ae);
	forwardInputs( );
}

bool Init_1aa::isInputUnique( const Udm::Object& rootFolder_1b7, const Udm::Object& configuration_1c0)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_1b9= _rootFolder_1b3.begin(), itConfiguration_1c2= _configuration_1bc.begin(); itRootFolder_1b9!= _rootFolder_1b3.end(), itConfiguration_1c2!= _configuration_1bc.end(); ++itRootFolder_1b9, ++itConfiguration_1c2)
	{
		if( ( *itRootFolder_1b9== rootFolder_1b7)&& ( *itConfiguration_1c2== configuration_1c0))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_1b3.push_back( rootFolder_1b7);
		_configuration_1bc.push_back( configuration_1c0);
	}
	return isUnique;
}

void Init_1aa::processInputPackets( const Packets_t& rootFolders_1ab, const Packets_t& configurations_1ae)
{
	for( Packets_t::const_iterator itRootFolder_1b4= rootFolders_1ab.begin(), itConfiguration_1bd= configurations_1ae.begin(); itRootFolder_1b4!= rootFolders_1ab.end(), itConfiguration_1bd!= configurations_1ae.end(); ++itRootFolder_1b4, ++itConfiguration_1bd)
	{
		bool isUnique= isInputUnique( *itRootFolder_1b4, *itConfiguration_1bd);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_1b4, *itConfiguration_1bd);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool Init_1aa::patternMatcher( const Udm::Object& rootFolder_1b5, const Udm::Object& configuration_1be)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_1b5.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_1ba= GReATConfig::RootFolder::Cast( rootFolder_1b5);
		if( false== Uml::IsDerivedFrom( configuration_1be.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_1c3= UMLModelTransformer::Configuration::Cast( configuration_1be);
		Match currMatch;
		currMatch.rootFolder_1c5= rootFolder_1ba;
		currMatch.configuration_1c6= configuration_1c3;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void Init_1aa::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::UsageInformation newUI_1c7= GReATConfig::UsageInformation::Create( currMatch.rootFolder_1c5);
		GReATConfig::MetaInformation newCMIF_1c8= GReATConfig::MetaInformation::Create( currMatch.rootFolder_1c5);
		GReATConfig::RuntimeInformation newRTI_1c9= GReATConfig::RuntimeInformation::Create( currMatch.rootFolder_1c5);
		GReATConfig::MetaInformation& CMIF= newCMIF_1c8;
		UMLModelTransformer::Configuration& Configuration= currMatch.configuration_1c6;
		GReATConfig::RuntimeInformation& RTI= newRTI_1c9;
		GReATConfig::RootFolder& RootFolder= currMatch.rootFolder_1c5;
		GReATConfig::UsageInformation& UI= newUI_1c7;
		{CMIF.SetStrVal("name", "1_MetaInfo"); UI.SetStrVal("name", "2_UserInfo"); RTI.SetStrVal("name", "3_RunTimeInfo"); };
		outputAppender( currMatch.rootFolder_1c5, currMatch.configuration_1c6);
	}
}

void Init_1aa::outputAppender( const GReATConfig::RootFolder& rootFolder_1ca, const UMLModelTransformer::Configuration& configuration_1cc)
{
	_rootFolder_1b1->push_back( rootFolder_1ca);
	_configuration_1b2->push_back( configuration_1cc);
}

void Init_1aa::forwardInputs()
{
	*_rootFolder_1b1= _rootFolder_1b3;
	*_configuration_1b2= _configuration_1bc;
}

