#include <UdmBase.h>
#include <cint_string.h>
#include "GReATConfig.h"
#include "UMLModelTransformer.h"
//#include "UMT2Config_2_UMLModelTransformer.h"

typedef std::list< Udm::Object> Packets_t;

// Forward declarations.
class UMT2Config_0;
class RunTimeInfo_13;
class UsageInfo_3c;
class UsageInfo_45;
class GetPath_74;
class Test_79;
class RuleCompound_90;
class TestCompound_b4;
class CompoundCompound_d8;
class StartRulePath_fc;
class Usagefile_123;
class TransformationInput_149;
class MetaInfo_181;
class Init_1aa;

// Class declarations.
class UMT2Config_0
{
public:
	void operator()( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3);

protected:
	void executeOne( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3);
	bool isInputUnique( const Udm::Object& confRF_7, const Udm::Object& umtConfigmodel_e);
	void callInit_1ce( const Packets_t& rootFolders_1ab, const Packets_t& configurations_1ae);
	void callMetaInfo_1d1( const Packets_t& rootFolders_182, const Packets_t& configurations_185);
	void callUsageInfo_1d4( const Packets_t& confRFs_3d, const Packets_t& umtConfigmodels_3f);
	void callRunTimeInfo_1d7( const Packets_t& rootFolders_14, const Packets_t& configurations_16);

private:
	Packets_t _confRF_5;
	Packets_t _umtConfigmodel_c;
};

class RunTimeInfo_13
{
public:
	void operator()( const Packets_t& rootFolders_14, const Packets_t& configurations_16);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_1c, const Udm::Object& configuration_25);
	void processInputPackets( const Packets_t& rootFolders_14, const Packets_t& configurations_16);
	bool patternMatcher( const Udm::Object& rootFolder_1a, const Udm::Object& configuration_23);
	void effector();
	void outputAppender();

private:
	Packets_t _rootFolder_18;
	Packets_t _configuration_21;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_35;
		UMLModelTransformer::Configuration configuration_36;
		UMLModelTransformer::FileType fileType_37;
		GReATConfig::RuntimeInformation runtimeInformation_38;
		UMLModelTransformer::File file_39;
		UMLModelTransformer::FileBind fileBindPseudo_32_3a;
	};

	std::list< Match> _matches;
};

class UsageInfo_3c
{
public:
	void operator()( const Packets_t& confRFs_3d, const Packets_t& umtConfigmodels_3f, Packets_t& outs_41, Packets_t& outs_42);

protected:
	void callUsageInfo_175( const Packets_t& rootFolders_46, const Packets_t& configurations_48);
	void callGetPath_178( const Packets_t& ins_75, const Packets_t& ins_77);
	void callUsagefile_17b( const Packets_t& usageInformations_124, const Packets_t& configurations_127);
	void callTransformationInput_17e( const Packets_t& usageInformations_14a, const Packets_t& fileTypes_14c);

private:
	Packets_t* _out_43;
	Packets_t* _out_44;
};

class UsageInfo_45
{
public:
	void operator()( const Packets_t& rootFolders_46, const Packets_t& configurations_48, Packets_t& configurations_4a, Packets_t& uIs_4b, Packets_t& expressions_4c);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_54, const Udm::Object& configuration_5d);
	void processInputPackets( const Packets_t& rootFolders_46, const Packets_t& configurations_48);
	bool patternMatcher( const Udm::Object& rootFolder_52, const Udm::Object& configuration_5b);
	void effector();
	void outputAppender( const UMLModelTransformer::Configuration& configuration_6e, const GReATConfig::UsageInformation& uI_70, const UMLModelTransformer::Expression& expression_72);

private:
	Packets_t* _configuration_4d;
	Packets_t* _uI_4e;
	Packets_t* _expression_4f;
	Packets_t _rootFolder_50;
	Packets_t _configuration_59;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_69;
		UMLModelTransformer::Configuration configuration_6a;
		GReATConfig::UsageInformation uI_6b;
		UMLModelTransformer::StartRule startRule_6c;
		UMLModelTransformer::Expression expression_6d;
	};

	std::list< Match> _matches;
};

class GetPath_74
{
public:
	void operator()( const Packets_t& ins_75, const Packets_t& ins_77);

protected:
	void callTest_11d( const Packets_t& ins_7a, const Packets_t& ins_7c);
	void callStartRulePath_120( const Packets_t& parents_fd, const Packets_t& uIs_100);
};

class Test_79
{
public:
	void operator()( const Packets_t& ins_7a, const Packets_t& ins_7c, Packets_t& outs_7e, Packets_t& outs_7f);

protected:
	void executeOne( const Packets_t& ins_7a, const Packets_t& ins_7c);
	bool isInputUnique( const Udm::Object& in_84, const Udm::Object& in_8b);

private:
	Packets_t* _out_80;
	Packets_t* _out_81;
	Packets_t _in_82;
	Packets_t _in_89;
};

class RuleCompound_90
{
public:
	bool operator()( const Packets_t& childs_91, const Packets_t& uIs_93, Packets_t& uIs_95, Packets_t& parents_96);

protected:
	bool isInputUnique( const Udm::Object& child_9d, const Udm::Object& uI_a6);
	void processInputPackets( const Packets_t& childs_91, const Packets_t& uIs_93);
	bool patternMatcher( const Udm::Object& child_9b, const Udm::Object& uI_a4);
	void outputAppender( const GReATConfig::UsageInformation& uI_b0, const UMLModelTransformer::CompoundRule& parent_b2);

private:
	Packets_t* _uI_97;
	Packets_t* _parent_98;
	Packets_t _child_99;
	Packets_t _uI_a2;
	class Match
	{
	public:
		UMLModelTransformer::Rule child_ad;
		GReATConfig::UsageInformation uI_ae;
		UMLModelTransformer::CompoundRule parent_af;
	};

	std::list< Match> _matches;
};

class TestCompound_b4
{
public:
	bool operator()( const Packets_t& childs_b5, const Packets_t& uIs_b7, Packets_t& uIs_b9, Packets_t& parents_ba);

protected:
	bool isInputUnique( const Udm::Object& child_c1, const Udm::Object& uI_ca);
	void processInputPackets( const Packets_t& childs_b5, const Packets_t& uIs_b7);
	bool patternMatcher( const Udm::Object& child_bf, const Udm::Object& uI_c8);
	void outputAppender( const GReATConfig::UsageInformation& uI_d4, const UMLModelTransformer::CompoundRule& parent_d6);

private:
	Packets_t* _uI_bb;
	Packets_t* _parent_bc;
	Packets_t _child_bd;
	Packets_t _uI_c6;
	class Match
	{
	public:
		UMLModelTransformer::Test child_d1;
		GReATConfig::UsageInformation uI_d2;
		UMLModelTransformer::CompoundRule parent_d3;
	};

	std::list< Match> _matches;
};

class CompoundCompound_d8
{
public:
	bool operator()( const Packets_t& childs_d9, const Packets_t& uIs_db, Packets_t& uIs_dd, Packets_t& parents_de);

protected:
	bool isInputUnique( const Udm::Object& child_e5, const Udm::Object& uI_ee);
	void processInputPackets( const Packets_t& childs_d9, const Packets_t& uIs_db);
	bool patternMatcher( const Udm::Object& child_e3, const Udm::Object& uI_ec);
	void outputAppender( const GReATConfig::UsageInformation& uI_f8, const UMLModelTransformer::CompoundRule& parent_fa);

private:
	Packets_t* _uI_df;
	Packets_t* _parent_e0;
	Packets_t _child_e1;
	Packets_t _uI_ea;
	class Match
	{
	public:
		UMLModelTransformer::CompoundRule child_f5;
		GReATConfig::UsageInformation uI_f6;
		UMLModelTransformer::CompoundRule parent_f7;
	};

	std::list< Match> _matches;
};

class StartRulePath_fc
{
public:
	void operator()( const Packets_t& parents_fd, const Packets_t& uIs_100, Packets_t& parents_ff, Packets_t& uIs_102);

protected:
	bool isInputUnique( const Udm::Object& parent_109, const Udm::Object& uI_112);
	void processInputPackets( const Packets_t& parents_fd, const Packets_t& uIs_100);
	bool patternMatcher( const Udm::Object& parent_107, const Udm::Object& uI_110);
	void effector();
	void outputAppender( const UMLModelTransformer::Expression& parent_119, const GReATConfig::UsageInformation& uI_11b);
	void forwardInputs();

private:
	Packets_t* _parent_103;
	Packets_t* _uI_104;
	Packets_t _parent_105;
	Packets_t _uI_10e;
	class Match
	{
	public:
		UMLModelTransformer::Expression parent_117;
		GReATConfig::UsageInformation uI_118;
	};

	std::list< Match> _matches;
};

class Usagefile_123
{
public:
	void operator()( const Packets_t& usageInformations_124, const Packets_t& configurations_127, Packets_t& usageInformations_126, Packets_t& fileTypes_129);

protected:
	bool isInputUnique( const Udm::Object& usageInformation_130, const Udm::Object& configuration_139);
	void processInputPackets( const Packets_t& usageInformations_124, const Packets_t& configurations_127);
	bool patternMatcher( const Udm::Object& usageInformation_12e, const Udm::Object& configuration_137);
	void effector();
	void outputAppender( const GReATConfig::UsageInformation& usageInformation_145, const UMLModelTransformer::FileType& fileType_147);

private:
	Packets_t* _usageInformation_12a;
	Packets_t* _fileType_12b;
	Packets_t _usageInformation_12c;
	Packets_t _configuration_135;
	class Match
	{
	public:
		GReATConfig::UsageInformation usageInformation_141;
		UMLModelTransformer::Configuration configuration_142;
		UMLModelTransformer::FileType fileType_143;
	};

	std::list< Match> _matches;
};

class TransformationInput_149
{
public:
	void operator()( const Packets_t& usageInformations_14a, const Packets_t& fileTypes_14c);

protected:
	bool isInputUnique( const Udm::Object& usageInformation_152, const Udm::Object& fileType_15b);
	void processInputPackets( const Packets_t& usageInformations_14a, const Packets_t& fileTypes_14c);
	bool patternMatcher( const Udm::Object& usageInformation_150, const Udm::Object& fileType_159);
	void effector();
	void outputAppender();

private:
	Packets_t _usageInformation_14e;
	Packets_t _fileType_157;
	class Match
	{
	public:
		UMLModelTransformer::StartRule startRule_16d;
		GReATConfig::UsageInformation usageInformation_16e;
		UMLModelTransformer::FileType fileType_16f;
		UMLModelTransformer::Expression expression_170;
		UMLModelTransformer::FileObject bObject_171;
		UMLModelTransformer::In in_172;
		UMLModelTransformer::TransformationInput transformationInputPseudo_165_173;
	};

	std::list< Match> _matches;
};

class MetaInfo_181
{
public:
	void operator()( const Packets_t& rootFolders_182, const Packets_t& configurations_185, Packets_t& rootFolders_184, Packets_t& configurations_187);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_18e, const Udm::Object& configuration_197);
	void processInputPackets( const Packets_t& rootFolders_182, const Packets_t& configurations_185);
	bool patternMatcher( const Udm::Object& rootFolder_18c, const Udm::Object& configuration_195);
	void effector();
	void outputAppender( const GReATConfig::RootFolder& rootFolder_1a6, const UMLModelTransformer::Configuration& configuration_1a8);
	void forwardInputs();

private:
	Packets_t* _rootFolder_188;
	Packets_t* _configuration_189;
	Packets_t _rootFolder_18a;
	Packets_t _configuration_193;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_1a2;
		UMLModelTransformer::Configuration configuration_1a3;
		UMLModelTransformer::MetaInformation mIF_1a4;
		GReATConfig::MetaInformation cMIF_1a5;
	};

	std::list< Match> _matches;
};

class Init_1aa
{
public:
	void operator()( const Packets_t& rootFolders_1ab, const Packets_t& configurations_1ae, Packets_t& rootFolders_1ad, Packets_t& configurations_1b0);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_1b7, const Udm::Object& configuration_1c0);
	void processInputPackets( const Packets_t& rootFolders_1ab, const Packets_t& configurations_1ae);
	bool patternMatcher( const Udm::Object& rootFolder_1b5, const Udm::Object& configuration_1be);
	void effector();
	void outputAppender( const GReATConfig::RootFolder& rootFolder_1ca, const UMLModelTransformer::Configuration& configuration_1cc);
	void forwardInputs();

private:
	Packets_t* _rootFolder_1b1;
	Packets_t* _configuration_1b2;
	Packets_t _rootFolder_1b3;
	Packets_t _configuration_1bc;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_1c5;
		UMLModelTransformer::Configuration configuration_1c6;
	};

	std::list< Match> _matches;
};

